#!/usr/bin/env python
import sys
import time
import Ice, IceStorm
import Combine
from threading import Thread

#------------------------------------------------------------------------------- 
class Publisher(Ice.Application):
  
    def run(self, args):
        datagram = False
        twoway = False
        optsSet = 0
        topicName = "hw_events"
        
        manager = IceStorm.TopicManagerPrx.checkedCast(self.communicator().propertyToProxy('TopicManager.Proxy'))
        if not manager:
            print args[0] + ": invalid proxy"
            return 1

        #
        # Retrieve the topic.
        #
        try:
            topic = manager.retrieve(topicName)
        except IceStorm.NoSuchTopic, e:
            try:
                topic = manager.create(topicName)
            except IceStorm.TopicExists, ex:
                print self.appName() + ": temporary error. try again"
                return 1

        #
        # Get the topic's publisher object, and create a hw proxy with
        # the mode specified as an argument of this application.
        #
        publisher = topic.getPublisher();
        if datagram:
            publisher = publisher.ice_datagram();
        elif twoway:
            # Do nothing.
            pass
        else: # if(oneway)
            publisher = publisher.ice_oneway();
        cmd_publisher = Combine.CommandPrx.uncheckedCast(publisher)
        
        inc = 0.0
        try:
            while 1:
                inc = inc+0.1
                cmd_publisher.cmd(inc)
                time.sleep(1)
        except IOError, e:
            # Ignore
            pass
        except Ice.CommunicatorDestroyedException, e:
            # Ignore
            pass


#------------------------------------------------------------------------------- 
class PublisherThread(Thread):
    
    #---------------------------------------------------------------------------
    def __init__(self, argv):
        Thread.__init__(self)
        self.argv = argv
    
    #---------------------------------------------------------------------------    
    def run(self):
        print 'Publisher thread running'
        pub = Publisher()
        pub.main(self.argv, "config.pub")
        print 'Publisher thread exiting'
        
#--------------------------------------------------------------------------
#
# Start from the command line
#
if __name__ == "__main__":
    print 'Starting client side publisher'
    pub_thread = PublisherThread(sys.argv)
    pub_thread.run()
    raw_input('Press any key to exit..')
  
    # Announce we are going 
    print 'Cient side publisher exiting'

  